using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class CannonControls : MonoBehaviour
{
    [SerializeField] private GameObject projectile;
    [SerializeField] private float shootingDelay;
    [SerializeField] private Collider[] cannonColliders;
    private float delay;
    private float framesLeftToShoot = 0f; // the number of frames passed since last shot

    void Start()
    {
        delay = shootingDelay;
    }

    void Update()
    {
        if(Input.GetKey(KeyCode.Space))
        {
            if (framesLeftToShoot <= 0f)
            {
                // start shooting cannonballs
                GameObject childObject = Instantiate(projectile) as GameObject;
                foreach (Collider collider in cannonColliders)
                    Physics.IgnoreCollision(childObject.GetComponent<SphereCollider>(), collider, true);
                childObject.transform.parent = gameObject.transform;
                childObject.transform.localPosition = new Vector3(0, 0, 0);
                
                if(delay > (shootingDelay * 1f) / 2f)
                    delay *= 0.95f;
                framesLeftToShoot = delay;
            }
            else
            {
                framesLeftToShoot -= Time.deltaTime;
            }
        }
        if (Input.GetKeyUp(KeyCode.Space))
        {
            delay = shootingDelay;
            framesLeftToShoot = 0f;
        }
    }
}
